# flags: --extend-ignore=Y037
from typing import Optional, TypeAlias, Union

MaybeCStr: TypeAlias = Optional[CStr]
CStr: TypeAlias = Union[C, str]
__version__: str = ...
__author__: str = ...

def make_default_c() -> C: ...

# Disallow forward refs for base classes
class D(C):  # F821 undefined name 'C'
    parent: C
    def __init__(self) -> None: ...

class C:
    other: C
    def __init__(self) -> None: ...
    def from_str(self, s: str) -> C: ...

class Outer:
    class Inner1: ...
    class Inner2(list[Outer.Inner1]): ...

# Allow forward references for argument annotations and the return type
def foo(x: SomeClass) -> SomeClass: ...
class SomeClass: ...

# Disallow forward references for default argument values
def bar(x: type = SomeOtherClass) -> None: ...  # Y011 Only simple default values allowed for typed arguments  # F821 undefined name 'SomeOtherClass'
class SomeOtherClass: ...

# Make sure pyflakes doesn't emit F821 for type-alias assignments to forward references (these are useful)
AliasBoundToForwardRef: TypeAlias = NotYetDefined
class NotYetDefined: ...

# Non-type alias assignments to forward references aren't particularly useful,
# but it would be confusing to disallow them, given that we allow type-alias assignments to forward references
NotATypeAlias = AlsoNotYetDefined
class AlsoNotYetDefined: ...
